;*********************************************************************
; OM-SoX, (c) 2011-2013 Marlon Schumacher (CIRMMT/McGill University) *
;             http://sourceforge.net/projects/omsox/                 *
;                                                                    *
;  Multichannel Audio Manipulation and Functional Batch Processing.  *
;        DSP based on SoX - (c) C.Bagwell and Contributors           *
;                  http://sox.sourceforge.net/                       *
;*********************************************************************
;
;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either version 2
;of the License, or (at your option) any later version.
;
;See file LICENSE for further informations on licensing terms.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,10 USA.
;
;Authors: M. Schumacher

(in-package :om)

; ==== SOX-MERGE ========================

(defclass! sox-merge (sox-input)
           (
            (gains :accessor gains :initarg :gains :initform nil :documentation *sox-gain-doc*)
            )
           (:icon 15)
           (:documentation "Sox-merge will 'stack' the channels of audio inputs into a single multichannel file.

The number of channels in input audio may differ. The resulting audio comprises all of the channels from all of the inputs in ascending order."
           )
)

(defmethod initialize-instance :after ((self sox-merge) &rest l)
   (declare (ignore l))
   (when (sound self)
     (sox-init-gains self)
     (sox-init-sound self 'list)
     )
   )



