; ********************************************************************
; OM-SoX, (c) 2011-2013 Marlon Schumacher (CIRMMT/McGill University) *
;           http://sourceforge.net/projects/omsox/                   *
;                                                                    *
;  Multichannel Audio Manipulation and Functional Batch Processing.  *
;       DSP based on SoX - (c) C.Bagwell and Contributors            *
;               http://sox.sourceforge.net/                          *
; ********************************************************************
;
;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either version 2
;of the License, or (at your option) any later version.
;
;See file LICENSE for further informations on licensing terms.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,10 USA.
;
;Authors: M. Schumacher

(in-package :om)

;;; sox-ladspa ===============================

(defmethod! sox-ladspa ((module pathname) (plugin string) (parameters t) &key sox-append)
  :icon 24
  :initvals '(nil nil nil)
  :indoc (list "Full path to LADSPA module" "Name of plugin (a module can contain more than one plugin)" "List of parameter values for plugin (missing arguments are supplied by default values if possible)" 
               *sox-append-doc*)
  :doc "Apply a LADSPA (Linux Audio Developer's Simple Plugin API) plugin. 

NB: Currently only monaural plugins (with one audio input and one audio output port) can be used."

  (let* (
         (thestring (format nil "ladspa '~d' ~d" module plugin)))
    (when parameters
      (loop for val in (list! parameters) do
            (setf thestring (concatenate 'string thestring 
                                   (format nil " ~a" val)))))
    (sox-concat sox-append thestring))
    )

;==================================================
;For now VST plugins don't work until sox supports the ladspa-based vst-wrapper
