;;;===========================================================================
;;; OM-Spat
;;; Rendering of spatial scene descriptions 
;;; J. Bresson (IRCAM - 2010)
;;;===========================================================================

;;;===========================================================================
;;; SPAT-MATRIX
;;;===========================================================================

(in-package :om)

(defclass! spat-matrix (class-array) 
  ((sounds :initarg :sounds :initform nil)
   (trajectories :initarg :trajectories :initform nil)
   (durations :initarg :durations :initform nil)
   (onsets :initarg :onsets :initform nil)
   (orientations :initarg :orientations :initform nil)
   (apertures :initarg :apertures :initform nil)
   (src-names :initarg :src-names :initform nil))
  (:documentation "
SPAT-MATRIX is a structured representation of a spatial sound scene.
The current available parameters are 

- <sounds> : list of sound sources
- <trajectories> : list of trajectories (BPC, 3DC or 3D-trajectory)
- <durations> : list of durations on which trajectories are eventually mapped
- <onsets> : list of onset times for beginning of sources palyback and movement
")
  (:icon 501))
   
(defmethod array-data-from-control ((controlvalue BPC) numcols)
  (loop for i from 0 to (- numcols 1)
        collect (eval (omng-copy controlvalue))))
