(in-package :om)


;;;================================================================================================================
;;; PM2 PATH
;;;================================================================================================================
;;; rajouter dans les prefs?

;;; si c'est dans une userlib il faut initialiser ici
(defvar *PM2-PATH* 
  (probe-file (om-external-app '("AudioSculpt" "Kernels") "pm2")))

;;; ... sinon comme ca :
(defun init-pm2 ()
  (setf *PM2-PATH* (om-external-app '("AudioSculpt" "Kernels") "pm2")))

;(add-init-user-func 'init-pm2)
(init-pm2)

;;; ... ou a la main
(defmethod! set-pm2-path ((path string))
  :icon 186
  (setf *PM2-PATH* (pathname path)))

(defmethod! set-pm2-path ((path pathname))
  :icon 186
  (setf *PM2-PATH* path))

(defmethod! set-pm2-path ((path null))
  :icon 186
  (setf *PM2-PATH* (om-choose-file-dialog :prompt "Please locate the pm2 kernel file")))

(defmethod! pm2-path (&optional (unix nil))
  :icon 186
  (let ((pa *PM2-PATH*))
    (if unix (om-path2cmdpath pa) 
        pa)))


;;;=====================
;;; PM2 PREFS

;(pushr 'pm2 *external-prefs*)
(add-external-pref-module 'pm2)

(defmethod get-external-name ((module (eql 'pm2))) "PM2")
(defmethod get-external-icon ((module (eql 'pm2))) (and (exist-lib-p "OM-pm2") (list 953 (exist-lib-p "OM-pm2"))))

(defmethod get-external-module-vals ((module (eql 'pm2)) modulepref) (get-pref modulepref :pm2-options))
(defmethod get-external-module-path ((module (eql 'pm2)) modulepref) (get-pref modulepref :pm2-path))
(defmethod set-external-module-vals ((module (eql 'pm2)) modulepref vals) (set-pref modulepref :pm2-options vals))
(defmethod set-external-module-path ((module (eql 'pm2)) modulepref path) 
  (set-pref modulepref :pm2-path path))


;;; params folder
(defun def-pm2-options ()
  nil)

(defmethod get-external-def-vals ((module (eql 'pm2))) 
  (list :pm2-path (om-external-app '("AudioSculpt" "Kernels") "pm2")
        :pm2-options (def-pm2-options)))

(defmethod save-external-prefs ((module (eql 'pm2))) 
  `(:pm2-path ,(om-save-pathname *PM2-PATH*) 
     :pm2-options nil))


(defmethod put-external-preferences ((module (eql 'pm2)) moduleprefs)
  (let ((list-prefs (get-pref moduleprefs :pm2-options)))
    (when list-prefs 
      nil ; pas d'options...
      )
    (when (get-pref moduleprefs :pm2-path)
      (setf *PM2-PATH* (find-true-external (get-pref moduleprefs :pm2-path))))
    ))


(defmethod show-external-prefs-dialog ((module (eql 'pm2)) prefvals)
  (om-beep-msg "NO OPTIONS FOR PM2")
  nil)
