;;;;============================================================================
;;;;               MyLib.lib
;;;;
;;;; MyLib library
;;;; authors: Gas Theropod, Otto Pus.
;;;; date: 18/1/98
;;;;============================================================================ 


; A small library template 
; contains 2 subpackages, "SubPackage1" and "SubPackage2"
;"SubPackage1" contains 1 generic function , "Addition", defined through 3 methods, depending on argument types
;"SubPackage2" contains 1 generic function , "Multiplication", defined through 3 methods, depending on argument types

; the methods and classes are defined in the source files SourceFile1.lisp and SourceFile2.lisp

;the methods are defined using "defmethod!"
;the classes are defined using "defclass!".

;============================================
; definition de "package"

(defvar diph)

(defpackage diph 
  (:use "COMMON-LISP" "OpenMusic" "OM" "OA" "CL-USER"))

;============================================
(in-package diph)

;--------------------------------------------------
;Variable definiton with files to load 
;--------------------------------------------------

(defvar *diph-sources-dir* "source files")
(setf *diph-sources-dir* (append (pathname-directory *load-pathname*) (list "sources")))


(defvar *MyLib-lib-files* nil)
(setf *MyLib-lib-files* '("OM_Diph_Source1"))

;--------------------------------------------------
;Loading & compiling files 
;--------------------------------------------------

(mapc #'(lambda (file) (compile&load (make-pathname :directory *diph-sources-dir* :name file))) *MyLib-lib-files*)

;--------------------------------------------------
; OM subpackages initialization
; ("sub-pack-name" subpacke-lists class-list function-list class-alias-list)
;--------------------------------------------------
(defvar *subpackages-list* nil)
(setf *subpackages-list*
      '( ("DiphoneScript" nil nil (DiphSave DiphSaveAs DiphOpendico DiphCreateDico DiphOpenSequence DiphSaveDescription DiphCreateSeq DiphCopyto DiphSegmentSet DiphSegmentAdd DiphSegmentMul DiphSegmentRatio DiphSegmentGlue DiphSegmentCoorMode DiphSegmentShape DiphSegmentArticul) nil)
         ("DiphoneMacro" nil nil (DiphBuildSequence DiphBuildRythme DiphSeq&Rythme DiphTimeStretch) nil)
         ("DiphoneUtilities" nil (Diph-Script) (SetDiphoneFolder DiphNameSeg GetDescription DiphExtract DiphPack DiphSequenceLength sdif2part-list WriteDiphScript WriteDiphScript2 ExecuteDiphScript WriteAppleScript WriteAppleScript2 DoSynthesis) nil)
         ))

;--------------------------------------------------
;filling packages
;--------------------------------------------------
(om::fill-library *subpackages-list*)



