(in-package :om)

;============================================================================
;     OMprisma 2.0,  2010 Marlon Schumacher (CIRMMT / McGill University)
;============================================================================
;----------------------------------------------------------------------------
;			 ABSTRACT CLASSES
;----------------------------------------------------------------------------

(defclass! prisma-event (cs-spat-evt) 
 ; soundfile player 
           (( soundfile	
              :type t
              :initarg :soundfile 
              :initform nil
              :accessor soundfile)
            ( gain	
              :type number
              :initarg :gain
              :initform 0.
              :accessor gain)
            ( gain-env
              :type GEN-07
              :initarg :gain-env
              :initform (make-cs-table  'Gen-07  '(0 512) '(1 1) 5 "?" 513) 
              :accessor gain-env)
            ( startpos
              :type number
              :initarg :startpos
              :initform 0.
              :accessor startpos)  
            ))



(defclass! prisma-discrete (prisma-event)
 ; discrete sourceposition 3D
           (( xpos
             :type number
             :initarg :xpos
             :initform 0.
             :accessor xpos)
           ( ypos
             :type number
             :initarg :ypos
             :initform 0.
             :accessor ypos)          
           ( zpos
             :type number
             :initarg :zpos
             :initform 0.
             :accessor zpos))
           )

(defclass! prisma-continuous (prisma-event)
 ; continuous sourceposition 3D
           (( xpos-env
              :type GEN-07
              :initarg :xpos-env
              :initform (make-cs-table  'Gen-07  '(0 512) '(0 0) 5 "?" 513)
              :accessor xpos-env)            
           ( ypos-env
             :type GEN-07
             :initarg :ypos-env
             :initform (make-cs-table  'Gen-07  '(0 512) '(0 0) 5 "?" 513)
             :accessor ypos-env)          
           ( zpos-env
             :type GEN-07
             :initarg :zpos-env
             :initform (make-cs-table  'Gen-07  '(0 512) '(0 0) 5 "?" 513)
             :accessor zpos-env)         
           ( xpos-freqenv
             :type GEN-07 ;; NB: if 0 1/duration (1 cycle per event)
             :initarg :xpos-freqenv 
             :initform 0
             :accessor xpos-freqenv)           
           ( ypos-freqenv
             :type GEN-07 ;; NB: if 0 1/duration (1 cycle per event)
             :initarg :ypos-freqenv 
             :initform 0
             :accessor ypos-freqenv)          
           ( zpos-freqenv
             :type GEN-07 ;; NB: if 0 1/duration (1 cycle per event)
             :initarg :zpos-freqenv 
             :initform 0
             :accessor zpos-freqenv))  
           )

(defclass! prisma-trajectory (prisma-event)
 ; trajectory sourceposition 3D
           (( pos-env
              :type BPC
              :initarg :pos-env
              :initform (traject-from-list '(0) '(0) '(0) '(0) '3D-trajectory)
              :accessor pos-env))
           )

(defclass! prisma-distance-cues ()
 ; distance cues
           (( atten-fun
              :type GEN-07 ;; NB: if 1,2 predefined function (201, 202) else tables
              :initarg :atten-fun 
              :initform 0
              :accessor atten-fun)
            
            ( air-fun
              :type GEN-07 ;; NB: if 1,2 predefined function (300, 301) else tables
              :initarg :air-fun 
              :initform 0
              :accessor air-fun)
            
            ( time-fun
              :type GEN-07 ;; NB: if 1 predefined function (401) else tables
              :initarg :time-fun 
              :initform 0
              :accessor time-fun)
            
            ( reference-distance
              :type number
              :initarg :reference-distance
              :initform 1
              :accessor reference-distance))
           )

; renderer-specific abstract classes

(defclass! prisma-ambi ()
  ()
  )

(defclass! prisma-babo ()
  ()
  )

(defclass! prisma-dbap ()
  ()
  )

(defclass! prisma-panning ()
  ()
  )

(defclass! prisma-rvbap ()
  ()
  )

(defclass! prisma-spat ()
  ()
  )

(defclass! prisma-vbap ()
  ()
  )

(defclass! prisma-vimic ()
  ()
  )


