(in-package :om)

;============================================================================
;     OMprisma 2.0,  2010 Marlon Schumacher (CIRMMT / McGill University)
;============================================================================
;----------------------------------------------------------------------------
;			 CLASS VIMIC.CONTINUOUS
;      	  continous control of distance-based amplitude panning
;                     with optional distance-cues
;----------------------------------------------------------------------------

(defclass! vimic.continuous (prisma-vimic prisma-distance-cues prisma-continuous)
   			
  (
   (source-code :initform
                 (load-buffer-textfile
                  (get-orc-source (get-orc "vimic.continuous" :local))
                  'textfile "append")
                 :allocation :class :type textfile :accessor source-code)
   (numchan :initform (or (get-orc-channels (get-orc "vimic.continuous")) 4) :allocation :class  :accessor numchan)
   (cs-inits :initform (get-cs-inits (get-orc "vimic.continuous")) :allocation :class :type list :accessor cs-inits)
   (orc-header :initform *vimic-default-tables* :allocation :class :type list :accessor orc-header)
   (InstID :initform 1  :allocation :class  :accessor InstID)
   

   ( yaw-env
     :type GEN-07
     :initarg :yaw-env
     :initform (make-cs-table  'Gen-07  '(0 512) '(0 0) 5 "?" 513)
     :accessor yaw-env)

   ( yaw-freqenv
	:type GEN-07 ;; NB: if 0 1/duration (1 cycle per event)
        :initarg :yaw-freqenv 
        :initform 0
        :accessor yaw-freqenv)

   ; DIRECTIVITY (2D) --------------------

   ( directivity-fun
	:type GEN-07
        :initarg :directivity-fun
        :initform 0
        :accessor directivity-fun)

   ; RENDERER SPECIFIC ---------------------

   ( mic-params
	:type multi-cs-table
        :initarg :mic-params
        :initform 0 ;; NB: if 0 omnis, else tables 
        :accessor mic-params)
   ) 

  (:documentation "N/A")
  (:icon 77)
  )

(defmethod ignore-pfields ((self vimic.continuous)) '("p5" "p6" "p7"))

;#|
(defmethod initialize-instance :after ((self vimic.continuous) &rest args)
  (when (equal (type-of (mic-params self)) 'mic-array) 
    (progn 
      (print "bingo")
    (setf (mic-params self) (mic-directivities (mic-params self))))) 
  ;(print (mic-directivities (mic-params self)))
  ;(setf (mic-params self) (mic-directivities (mic-params self)))
  ;(setf (mic-params self) (mic-params self))
  self)

;I think this needs a :before but not sure how to do this.

;|#
