(in-package :om)

;============================================================================
;     OMprisma 2.0,  2010 Marlon Schumacher (CIRMMT / McGill University)
;============================================================================
;----------------------------------------------------------------------------
;			 CLASS VIMIC.DISCRETE
;      	  discrete control of distance-based amplitude panning 
;                     with optional distance cues
;----------------------------------------------------------------------------

(defclass! vimic.discrete (prisma-vimic prisma-distance-cues prisma-discrete)
   			
  (
   (source-code :initform
                 (load-buffer-textfile
                  (get-orc-source (get-orc "vimic.discrete" :local))
                  'textfile "append")
                 :allocation :class :type textfile :accessor source-code)
   (numchan :initform (or (get-orc-channels (get-orc "vimic.discrete")) 8) :allocation :class  :accessor numchan)
   (cs-inits :initform (get-cs-inits (get-orc "vimic.discrete")) :allocation :class :type list :accessor cs-inits)
   (orc-header :initform *vimic-default-tables* :allocation :class :type list :accessor orc-header)
   (InstID :initform 1  :allocation :class  :accessor InstID)

   ( yaw
	:type number
        :initarg :yaw
        :initform 0.
        :accessor yaw)

   ; DIRECTIVITY (2D) --------------------

   ( directivity-fun
	:type GEN-07
        :initarg :directivity-fun
        :initform 0
        :accessor directivity-fun)

   ; RENDERER SPECIFIC ---------------------

   ( mic-params
	:type multi-cs-table
        :initarg :mic-params
        :initform 0 ;; NB: if 0 omnis, else tables 
        :accessor mic-params)

   )

  (:documentation 
"

")
  (:icon 77)
  )

(defmethod ignore-pfields ((self vimic.discrete)) '("p5" "p6" "p7"))
