

(in-package :om)

(defclass prisma-init () 
  ((setup-data :initarg :setup-data :initform nil :accessor setup-data)
   (osc        :initarg :osc        :initform nil :accessor osc)))

(defclass setup-init (prisma-init) ())
(defclass order-init (prisma-init) ())


; prisma-setup ----------

(defmethod! prisma-setup ((setup-data symbol) &optional osc)
  :icon 47
  :menuins (list (list 0 *prisma-ls-configs-programs*))
  :initvals (list *prisma-lsconfig-stereo* t)
  ;(print setup-data)
  ;(make-instance 'setup-init :setup-data (speaker-presets setup-data) :osc osc))
  (make-instance 'setup-init :setup-data (speaker-presets setup-data osc) :osc osc))

(defmethod! prisma-setup ((setup-data t) &optional osc)
  (make-instance 'setup-init :setup-data (speaker-presets setup-data osc) :osc osc))


; prisma-order -----------

(defmethod! prisma-order (setup-data &optional osc)
            :icon 47
            :initvals '("2D.3rd-order" nil)
            :menuins '((0 (("2D.1st-order" "2D.1st-order")("2D.2nd-order" "2D.2nd-order")
                           ("2D.3rd-order" "2D.3rd-order")("3D.1st-order" "3D.1st-order")
                           ("3D.2nd-order" "3D.2nd-order")("3D.3rd-order" "3D.3rd-order")
                           ("UHJ" "UHJ")
                           )))   
            (make-instance 'order-init :setup-data setup-data :osc osc))


(defmethod format-init ((self prisma-init) cs-events)
  (let ((prisma-classes nil))
    (loop for evt in cs-events do
          (when (and (subtypep (type-of evt) 'cs-spat-evt)
                     (not (find (type-of evt) prisma-classes :test 'equal :key 'type-of)))
            (push evt prisma-classes)))
    (flat (mapcar #'(lambda (c) (format-init-for-class self c)) prisma-classes))))


;;; SETUP DOES NOT APPLY FOR AMBI AND SPAT
(defmethod format-init-for-class ((self setup-init) (class t)) nil)

(defmethod format-init-for-class ((self setup-init) (class prisma-babo))
  (babo-setup (setup-data self) (osc self)))

(defmethod format-init-for-class ((self setup-init) (class prisma-dbap))
  (print (osc self))
  (dbap-setup (setup-data self) (osc self)))

(defmethod format-init-for-class ((self setup-init) (class prisma-panning))
  (pan-setup (setup-data self) (osc self)))

(defmethod format-init-for-class ((self setup-init) (class prisma-rvbap))
  (rvbap-setup (setup-data self) (osc self)))

(defmethod format-init-for-class ((self setup-init) (class prisma-vbap))
  (vbap-setup (setup-data self) (osc self)))

(defmethod format-init-for-class ((self setup-init) (class prisma-vimic))
  (vimic-setup (setup-data self) (osc self)))

(defmethod format-init-for-class ((self setup-init) (class prisma-ambi))
  (ambi-setup (setup-data self) (osc self)))

(defmethod format-init-for-class ((self setup-init) (class prisma-spat))
  (spat-setup (setup-data self) (osc self)))

;;; ORDER ONLY APPLY FOR AMBI AND SPAT

(defmethod format-init-for-class ((self order-init) (class t)) nil)

;(defmethod format-init-for-class ((self prisma-order) (class prisma-hoa)) 
;  (hoa-setup (setup-data self) (osc self)))

(defmethod format-init-for-class ((self order-init) (class prisma-ambi)) 
  (ambi-setup (setup-data self) (osc self)))

;(defmethod format-init-for-class ((self prisma-init) (class prisma-ambi))
;  (ambi-setup (setup-data self) (osc self)))

(defmethod format-init-for-class ((self order-init) (class prisma-spat))
  (spat-setup (setup-data self) (osc self)))


