;OMPrisma,  2010 M.Schumacher (CIRMMT, McGill University)
; 
;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either version 2
;of the License, or (at your option) any later version.
;
;See file LICENSE for further informations on licensing terms.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,10 USA.
;
;Authors: M. Schumacher

(in-package :om)

; would be better to define a class 'omprisma-evt for these methods
; (not all cs-spat-event may have slots xpos-env, etc.

(defmethod get-array-trajectories ((self spat-trajectory-evt))
  (find-array-field self :pos-env))

(defmethod get-array-trajectories ((self cs-spat-evt))
  (let ((xtables (find-array-field self :xpos-env))
        (ytables (find-array-field self :ypos-env))
        (ztables (find-array-field self :zpos-env)))
    (mapcar #'(lambda (xtab ytab ztab) (3DC-from-list (y-points xtab) (y-points ytab) (y-points ztab) '3DC 6))
            xtables ytables ztables)))

(defmethod find-array-field ((array cs-spat-evt) field)
  (cond ((equal field :sounds) (find-array-field array :soundfile))
        ((equal field :trajectories) (get-array-trajectories array))
        ((equal field :durations) (find-array-field array :durs))
        ((equal field :onsets) (find-array-field array :e-dels))
        (t (call-next-method))))
         
