;OMprisma 2.0,  2010 M.Schumacher (CIRMMT, McGill University)
; 
;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either version 2
;of the License, or (at your option) any later version.
;
;See file LICENSE for further informations on licensing terms.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,10 USA.
;
;Authors: M. Schumacher

(in-package :om)

;;; Color BPF-objects

(defmethod! bpf-colour ((bpf bpf) &key r g b)
            :icon '(402)
  (setf (bpfcolor bpf) (om-make-color (or r (om-random 0. 1.0))
                                      (or g (om-random 0. 1.0))
                                      (or b (om-random 0. 1.0))))
  bpf)

(defmethod! bpf-ran-colour ((bpf bpf) &key r g b)
                (bpf-colour bpf :r r :g g :b b))



(defmethod! bpf-colour ((bpf list) &key r g b)
   (let ((nbcolor (length bpf)))
     (loop for onebpf in bpf collect
           (bpf-colour onebpf :r r :g g :b b))
     ))

;%%%%%%%%%%% visualize 3D-points 

(defmethod! traj-visualize ((self t))
           :icon '(22)
           (let ((thelist (list! self)))

             (loop for item in thelist collect ;item is a matrix
                   (cond (((subtypep item prisma-discrete) (display-discrete item))
                          ((subtypep item prisma-continuous) (display-continuous item))
                          ((subtypep item prisma-trajectory) (display-continuous item))) ;should be changed later
                         )
                   )
             )
           )

(defmethod! display-discrete ((self prisma-event))
            (3DC-from-list (xpos self) (ypos self) (or (zpos self) '(0 0)) '3DC)                
                  )

(defmethod! display-continuous ((self prisma-event))
            (loop for item in (xpos-env self) 
                  for item in (ypos-env self) 
                  for item in (zpos-env self) collect
                  (3dc-from-list (y-points (xpos-env item)) (y-points (ypos-env item)) (y-points (zpos-env item)) '3DC (decimals item))                
                  )
            )


(defmethod! display-3D.discrete ((self t))
            ;how do i get the list! working here?
            (list! self)
            (loop for item in self collect
                  (3DC-from-list (xpos item) (ypos item) (zpos item) '3DC)                
                  )
            )

;%%%%%%%%%%%% visualize 3D-trajectories

(defmethod! display-3D.continuous ((self cs-spat-evt))
            (loop for item in (xpos-env self) 
                  for item in (ypos-env self) 
                  for item in (zpos-env self) collect
                  (3dc-from-list (y-points (xpos-env item)) (y-points (ypos-env item)) (y-points (zpos-env item)) '3DC (decimals item))                
                  )
            )


;%%%%%%%%%%% visualize 2D-points 

(defmethod! display-2D.discrete ((self t))
            (list! self)
           (let ((thebpclist
                  (loop for item in self collect
                  (simple-bpf-from-list (xpos item) (ypos item) 'bpc 10)                
                  )))
             (bpf-ran-colour thebpclist)
            ))

;%%%%%%%%%%%% visualize 2D-trajectories

(defmethod! display-2D.continuous ((self cs-spat-evt))
            (loop for item in (xpos-env self) 
                  for item in (ypos-env self) collect
                  (simple-bpf-from-list (y-points (xpos-env item)) (y-points (ypos-env item)) 'bpc)                
                  )
            )
